/**
 * An interface specifying the operations that should be supported
 * by a dynamic FIFO queue abstract data type.
 *
 * @author Peter Lemieszewski
 * @version 1.0
 */
import java.lang.Exception;
import java.util.NoSuchElementException;
public interface IQueue{

    /**
     * Adds an object to the queue.
     *
     * @param Object o the object to be added to the queue.
     * @return true if the object was added, false if it was already present.
     * ignore for lab - throws NullPointerException - if the specified element is null	 
     */
    //ignore for lab - public boolean enqueue(Object o) throws NullPointerException;
    public boolean enqueue(Object o);

    /**
     * Removes an object from the queue.
     *
     * @param Object o the object to be removed from the queue.
     * @return true if the object was removed, false if it was not present in
     * the queue.
     * @throws NoSuchElementException - if this queue is empty	 
     */
    public boolean dequeue(Object o) throws NoSuchElementException;

    /**
     * Returns the number of elements in the queue.
     *
     * @return the number of elements in the queue.
     */
    public int getSize();

    /**
     * Returns a String representation of the queue elements.
     *
     * @return the string representation of the queue.
     */
    public String toString();
}
