/**
 * An interface specifying the operations that should be supported
 * by a dynamic LIFO stack abstract data type.
 *
 * @author Peter Lemieszewski
 * @version 1.0
 */
import java.lang.Exception;
import java.util.NoSuchElementException;
public interface IStack{

    /**
     * Adds an object to the Stack.
     *
     * @param Object o the object to be added to the Stack.
     * @return true if the object was added, false if it was already present.
     * ignore for lab - throws NullPointerException - if the specified element is null	 
     */
    // ignore for lab - public boolean push(Object o) throws NullPointerException;
    public boolean push(Object o);
    /**
     * Removes an object from the Stack.
     *
     * @param Object o the object to be removed from the Stack.
     * @return true if the object was removed, false if it was not present in
     * the Stack.
	 * @throws NoSuchElementException - if this Stack is empty	 
     */
    public boolean pop(Object o) throws NoSuchElementException;

    /**
     * Returns the number of elements in the Stack.
     *
     * @return the number of elements in the Stack.
     */
    public int getSize();

    /**
     * Returns a String representation of the Stack elements.
     *
     * @return the string representation of the Stack.
     */
    public String toString();
}
