/**
 * A class that implements the queue interface using your linked list.
 *
 * @author Pete Lemieszewski
 * @version 1.0
 */
import java.lang.Exception;
import java.util.NoSuchElementException;
public class QueueMyLinkedList implements IQueue{
    MyLinkedList que;
    public QueueMyLinkedList() {
        que = new MyLinkedList();   
    }

    /**
     * Returns the number of elements in the queue.
     *
     * @return the number of elements in the queue.
     */
    public int getSize()
    {
        return que.getLength();   
    }

    /**
     * Adds an object to the queue.
     *
     * @param Object o the object to be added to the queue.
     * @return true if the object was added, false if it was already present.
     * @throws NullPointerException - if the specified element is null	 
     */
    public boolean enqueue(Object o) throws NullPointerException
    {
        if (o.equals(null)) {
            throw new NullPointerException();
        }
        que.add(o);  //add to the end of the queue  
        return true;
    }

    /**
     * Removes an object from the front of queue.
     *
     * @param 
     * @return the object at the front of the queue
     * @throws NoSuchElementException - if this queue is empty	 
     */
    public Object dequeue() throws NoSuchElementException
    {
        int size = getSize();
        if (size == 0)
            throw new NoSuchElementException();            
        return que.remove(0); //remove from the beginning of the queue
    }

    /**
     * Returns a String representation of the queue elements.
     *
     * @return the string representation of the queue.
     */
    public String toString() 
    {
        return que.toString();
    }
}

