/**
 * A class that implements the queue interface using your linked list.
 *
 * @author
 * @version
 */
import java.lang.Exception;
import java.util.NoSuchElementException;
public class StackMyLinkedList implements IStack{
    MyLinkedList stack;
    public StackMyLinkedList() {
        stack = new MyLinkedList();   
    }

    /**
     * Adds an object to the Stack.
     *
     * @param Object o the object to be added to the Stack.
     * @return true if the object was added, false if it was already present.
	 * @throws NullPointerException - if the specified element is null	 
     */
    public boolean push(Object o) throws NullPointerException
    {
        if (o.equals(null)) {
            throw new NullPointerException();
        }
        stack.add(o,0); // add to the top        
        return true;        
    }

    /**
     * Removes an object from the Stack.
     *
     * @param 
     * @return true if the object was removed, false if it was not present in
     * the Stack.
	 * @throws NoSuchElementException - if this Stack is empty	 
     */    
    public Object pop() throws NoSuchElementException
    {
        int size = getSize();
        if (size == 0)
            throw new NoSuchElementException();            
        return stack.remove(0); // remove from the top
    }

    /**
     * Returns the number of elements in the Stack.
     *
     * @return the number of elements in the Stack.
     */
    public int getSize()
    {
      return stack.getLength();  
    }

    /**
     * Returns a String representation of the Stack elements.
     *
     * @return the string representation of the Stack.
     */
    public String toString()
    {
        return stack.toString();
    }

}

